program RealClock;
uses Dos,Crt,Graph;
const R=100;
var  Xc,Yc,asec,amin,ahr,k,c1,c2,c3,c4,c5,c6,
     d1,d2,d3,d4,d5,d6,d7,d8:integer;
     hr,min,sec,hund,y,m,d,dow:word;
     Ch:char;
procedure GrInit;
var GraphDriver,GraphMode,ErrorCode:integer;
begin
  GraphDriver:=Detect;
  InitGraph(GraphDriver,GraphMode,'');
  ErrorCode:=GraphResult;
  if ErrorCode<>grOk then
  begin
    writeln('Graphic Initialization Error!');
    writeln(GraphErrorMsg(ErrorCode));
    writeln('Exiting Program...');
    delay(50000);
    Halt(1);
  end;
end;
procedure Zastavka;
begin
  SetColor(Green);
  OutTextXY(Xc-70,Yc-40,'Program RealClock');
  OutTextXY(Xc-35,Yc-25,'ver 1.0');
  OutTextXY(Xc-18,Yc-10,'by');
  OutTextXY(Xc-55,Yc+5,'Plaksin Alex.');
  SetColor(Red);
  Rectangle(Xc-80,Yc-50,Xc+75,Yc+20);
  SetColor(White);
end;
procedure Galochka(x,y:integer);
begin
  putpixel(x,y,Green);
  putpixel(x-1,y-1,Green);
  putpixel(x-2,y-2,Green);
  putpixel(x+1,y-1,Green);
  putpixel(x+2,y-2,Green);
  putpixel(x+3,y-3,Green);
end;
procedure Vubor;
begin
  SetFillStyle(1,Magenta);
  Bar(Xc-70,Yc-30,Xc+70,Yc+40);
  SetFillStyle(1,Black);
  Bar(Xc-60,Yc,Xc-50,Yc+10);
  Bar(Xc-60,Yc+20,Xc-50,Yc+30);
  SetColor(LightMagenta);
  OutTextXY(Xc-40,Yc+1,'Meh');
  OutTextXY(Xc-40,Yc+21,'Electro');
  SetColor(Blue);
  OutTextXY(Xc-60,Yc-25,'Select a clock.');
  Line(Xc-65,Yc-15,Xc+65,Yc-15);
  SetColor(White);
  Galochka(Xc-55,Yc+6);
  k:=1;
  repeat
    Ch:=Readkey;
    case Ch of
      #72:
        begin
          Bar(Xc-60,Yc+20,Xc-50,Yc+30);
          Galochka(Xc-55,Yc+6);
          k:=1;
        end;
      #80:
        begin
          Bar(Xc-60,Yc,Xc-50,Yc+10);
          Galochka(Xc-55,Yc+26);
          k:=2;
        end;
    end;
  until Ch=#13;
end;
procedure KarkasMeh;
var x,y,i,h:integer;
    hstr:string;
begin
  i:=0;
  h:=3;
  repeat
    x:=Xc+round(R*cos(i*pi/180));
    y:=Yc-round(R*sin(i*pi/180));
    if i mod 30=0 then
    begin
      Circle(x,y,2);
      Str(h,hstr);
      x:=Xc+round((R+15)*cos(i*pi/180));
      y:=Yc-round((R+15)*sin(i*pi/180));
      OutTextXY(x-5,y-5,hstr);
      dec(h);
      if h=0 then h:=12;
    end
    else Circle(x,y,1);
    i:=i+6;
  until i=360;
end;
procedure Strelka(a,l:integer);
var x,y:integer;
begin
  x:=Round(Xc+l*cos(a*pi/180));
  y:=Round(Yc-l*sin(a*pi/180));
  Line(Xc,Yc,x,y);
end;
procedure DrawMeh;
begin
  asec:=90-sec*6;
  amin:=90-min*6;
  ahr:=90-hr*30-(min div 12)*6;
  SetColor(Black);
  SetLineStyle(0,0,1);
  Strelka(asec,R-10);
  SetLineStyle(0,0,2);
  Strelka(amin,R-20);
  SetLineStyle(0,0,3);
  Strelka(ahr,R-30);
  GetTime(hr,min,sec,hund);
  asec:=90-sec*6;
  amin:=90-min*6;
  ahr:=90-hr*30-(min div 12)*6;
  SetColor(Blue);
  SetLineStyle(0,0,1);
  Strelka(asec,R-10);
  SetColor(Green);
  SetLineStyle(0,0,2);
  Strelka(amin,R-20);
  SetColor(Red);
  SetLineStyle(0,0,3);
  Strelka(ahr,R-30);
  SetColor(White);
end;
procedure Zero(xn,yn:integer);
begin
  Rectangle(0+xn,0+yn,5+xn,10+yn);
end;
procedure One(xn,yn:integer);
begin
  Line(5+xn,0+yn,5+xn,10+yn);
end;
procedure Two(xn,yn:integer);
begin
  Line(0+xn,0+yn,5+xn,0+yn);
  Line(5+xn,0+yn,5+xn,5+yn);
  Line(5+xn,5+yn,0+xn,5+yn);
  Line(0+xn,5+yn,0+xn,10+yn);
  Line(0+xn,10+yn,5+xn,10+yn);
end;
procedure Three(xn,yn:integer);
begin
  Line(0+xn,0+yn,5+xn,0+yn);
  Line(5+xn,0+yn,5+xn,5+yn);
  Line(5+xn,5+yn,0+xn,5+yn);
  Line(5+xn,5+yn,5+xn,10+yn);
  Line(0+xn,10+yn,5+xn,10+yn);
end;
procedure Fouhr(xn,yn:integer);
begin
  Line(0+xn,0+yn,0+xn,5+yn);
  Line(5+xn,0+yn,5+xn,5+yn);
  Line(5+xn,5+yn,0+xn,5+yn);
  Line(5+xn,5+yn,5+xn,10+yn);
end;
procedure Five(xn,yn:integer);
begin
  Line(0+xn,0+yn,5+xn,0+yn);
  Line(0+xn,0+yn,0+xn,5+yn);
  Line(5+xn,5+yn,0+xn,5+yn);
  Line(5+xn,5+yn,5+xn,10+yn);
  Line(0+xn,10+yn,5+xn,10+yn);
end;
procedure Six(xn,yn:integer);
begin
  Line(0+xn,0+yn,5+xn,0+yn);
  Line(0+xn,0+yn,0+xn,5+yn);
  Line(5+xn,5+yn,0+xn,5+yn);
  Line(5+xn,5+yn,5+xn,10+yn);
  Line(0+xn,10+yn,5+xn,10+yn);
  Line(0+xn,5+yn,0+xn,10+yn);
end;
procedure Seven(xn,yn:integer);
begin
  Line(0+xn,0+yn,5+xn,0+yn);
  Line(5+xn,0+yn,5+xn,10+yn);
end;
procedure Eight(xn,yn:integer);
begin
  Rectangle(0+xn,0+yn,5+xn,10+yn);
  Line(0+xn,5+yn,5+xn,5+yn);
end;
procedure Nine(xn,yn:integer);
begin
  Line(0+xn,0+yn,5+xn,0+yn);
  Line(5+xn,0+yn,5+xn,5+yn);
  Line(5+xn,5+yn,0+xn,5+yn);
  Line(5+xn,5+yn,5+xn,10+yn);
  Line(0+xn,10+yn,5+xn,10+yn);
  Line(0+xn,0+yn,0+xn,5+yn);
end;
procedure Number(n,xn,yn:integer);
begin
  case n of
    0:Zero(xn,yn);
    1:One(xn,yn);
    2:Two(xn,yn);
    3:Three(xn,yn);
    4:Fouhr(xn,yn);
    5:Five(xn,yn);
    6:Six(xn,yn);
    7:Seven(xn,yn);
    8:Eight(xn,yn);
    9:Nine(xn,yn);
  end;
end;
procedure KarkasElectro;
begin
  Rectangle(Xc-40,Yc-15,Xc+36,Yc+15);
  putpixel(Xc-40+25,Yc-3,Green);
  putpixel(Xc-40+25,Yc+3,Green);
  putpixel(Xc-40+50,Yc-3,Green);
  putpixel(Xc-40+50,Yc+3,Green);
end;
procedure DrawElectro;
begin
  c1:=hr div 10;
  c2:=hr mod 10;
  c3:=min div 10;
  c4:=min mod 10;
  c5:=sec div 10;
  c6:=sec mod 10;
  SetColor(Black);
  Number(c1,Xc-40+5,Yc-15+10);
  Number(c2,Xc-40+15,Yc-15+10);
  Number(c3,Xc-40+30,Yc-15+10);
  Number(c4,Xc-40+40,Yc-15+10);
  Number(c5,Xc-40+55,Yc-15+10);
  Number(c6,Xc-40+65,Yc-15+10);
  GetTime(hr,min,sec,hund);
  c1:=hr div 10;
  c2:=hr mod 10;
  c3:=min div 10;
  c4:=min mod 10;
  c5:=sec div 10;
  c6:=sec mod 10;
  SetColor(Green);
  Number(c1,Xc-40+5,Yc-15+10);
  Number(c2,Xc-40+15,Yc-15+10);
  Number(c3,Xc-40+30,Yc-15+10);
  Number(c4,Xc-40+40,Yc-15+10);
  Number(c5,Xc-40+55,Yc-15+10);
  Number(c6,Xc-40+65,Yc-15+10);
  SetColor(White);
end;
procedure Date;
begin
  GetDate(y,m,d,dow);
  d1:=d div 10;
  d2:=d mod 10;
  d3:=m div 10;
  d4:=m mod 10;
  d5:=y div 1000;
  d6:=y div 100 mod 10;
  d7:=y div 10 mod 100;
  d8:=y mod 1000;
  SetColor(Red);
  Number(d1,GetMaxX-40-18,GetMaxY-15);
  Number(d2,GetMaxX-35-16,GetMaxY-15);
  putpixel(GetMaxX-30-14,GetMaxY-5,Red);
  Number(d3,GetMaxX-30-12,GetMaxY-15);
  Number(d4,GetMaxX-25-10,GetMaxY-15);
  putpixel(GetMaxX-20-8,GetMaxY-5,Red);
  Number(d5,GetMaxX-20-6,GetMaxY-15);
  Number(d6,GetMaxX-15-4,GetMaxY-15);
  Number(d7,GetMaxX-10-2,GetMaxY-15);
  Number(d8,GetMaxX-5,GetMaxY-15);
  OutTextXY(GetMaxX-115,GetMaxY-12,'DATE :');
  SetColor(White);

end;
BEGIN ClrScr;
  GrInit;
  Xc:=GetMaxX div 2;
  Yc:=GetMaxY div 2;
  Zastavka;
  ReadKey;
  ClearViewPort;
  Vubor;
  ClearViewPort;
  Date;
  GetTime(hr,min,sec,hund);
  case k of
    1:
      begin
        KarkasMeh;
        repeat
          delay(1000);
          DrawMeh;
        until KeyPressed;
      end;
    2:
      begin
        KarkasElectro;
        repeat
          delay(1000);
          DrawElectro;
        until KeyPressed;
      end;
  end;
  ReadKey;
  CloseGraph;
END.